/**
 * $Id$
 * 
 * Copyright 1993-2006, John J. Allen.
 * Released under the GNU GPL v2 or later.
 */

#if !defined(SYSDEP_HPP)
#define SYSDEP_HPP

#if defined(__DPMI16__)
#error 16bit DPMI not supported
#endif

#if defined(__DPMI32__)
#define __DOS32__
#endif

#if defined(_WIN32) || defined(__WIN32__)
	#if !defined(__WIN32__)
		#define __WIN32__
   #endif

	#if !defined(_WIN32)
		#define _WIN32
   #endif

	#include <windows.h>
#endif

#if defined(__MSDOS__)
	#include <dos.h>
#endif

 #if defined(__OS2__) && !defined(OS2_INCLUDED)
	#define INCL_PM
	#define INCL_BASE
	#include <os2.h>
#endif

#if defined(__DLL__)
	#if defined(__OS2__)
		#define EXP_FUNC	_export
		#define EXP_CLASS	_export
		#define EXP_DATA	_export
	#elif defined(__DPMI32__)
		#define EXP_FUNC	__export
		#define EXP_CLASS	__export
		#define EXP_DATA  __export
	#elif defined(__WIN32__) && defined(_MSC)
		#define EXP_FUNC	__declspec(dllexport)
		#define EXP_CLASS	__declspec(dllexport)
		#define EXP_DATA  __declspec(dllexport)
	#elif defined(__WIN32__) && defined(__BORLANDC__)
		#define EXP_FUNC	__export
		#define EXP_CLASS	__export
		#define EXP_DATA	__export
	#elif defined(__MSDOS__)
		#error DLLs under DOS WOW!
	#elif 1
		#error Unknown OS & Compiler combo for DLL generation
	#endif
#else
	#if defined(__OS2__)
		#define EXP_FUNC
		#define EXP_CLASS
		#define EXP_DATA
	#elif defined(__DPMI32__)
		#define EXP_FUNC
		#define EXP_CLASS
		#define EXP_DATA
	#elif defined(__WIN32__) && defined(_MSC)
		#define EXP_FUNC	__declspec(dllimport)
		#define EXP_CLASS	__declspec(dllimport)
		#define EXP_DATA
	#elif defined(__WIN32__) && defined(__BORLANDC__)
		#define EXP_FUNC	__import
		#define EXP_CLASS	__import
		#define EXP_DATA  
	#elif defined(__MSDOS__)
		#define EXP_FUNC
		#define EXP_CLASS
		#define EXP_DATA
	#elif 1
		#error Unknown OS & Compiler combo for DLL usage
	#endif
#endif

#if defined(__GNUG__)
	#define EXIT_SUCCESS 0
	#define EXIT_FAILURE 1
#endif

#if defined(__GO32__)
	#include <go32.h>
#endif

#if defined(__WINDOWS__) || defined(_Windows)
	#define __WINDOWS__
	#include <windows.h>
#endif

#if defined(__MACINTOSH__) || defined(Macintosh)
	#define __MACINTOSH__
	#include <Mac #includes.cpp>
#endif

#if defined(WIN32) && !defined(__WINDOWS__)

#endif

// include some of the most standard includes.
// NOTE: this helps with precompiled headers
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <limits.h>

#endif

//------------------------------------oOo-----------------------------------//
